#!/usr/bin/perl -w

# spam4.pl
# Spam Received header filter.
# by Javantea

# Received: from hostname (reverse_dns [ip])
#	by hostname (Name) with protocol id id#
#	for <jvoss@altsci.com>; Fri,  2 Jun 2006 10:58:35 -0700 (PDT)

$recv_tab = 0;

sub checkRecvd()
{
	my $data = shift;
	my $hostname = '';
	my $reverse_dns = '';
	my $ip = '';
	if(/from ([^ ]+) \(([^ ]*) ?\[([^\]]*)\]\)/)
	{
		$hostname = $1;
		$reverse_dns = $2;
		$ip = $3;
		#print "from1: $hostname $reverse_dns $ip\n";
	}
	my %ret = ("data",$data, "hostname",$hostname, "reverse_dns",$reverse_dns, "ip",$ip);
	#print $ret{'hostname'} ."\n";
	return %ret;
}

while(<STDIN>)
{
	if(!$recv_tab && /^Received:/)
	{
		%retd = &checkRecvd($_);
		if($retd{'ip'} ne '') {
			print $retd{'ip'} . "\n";
		}
		$recv_tab = 1;
	}
	elsif($recv_tab && /^\t/)
	{
		# recv_tab seems essentially worthless (maybe 1 actual box)
		%retd = &checkRecvd($_);
		if($retd{'ip'} ne '') {
			print $retd{'ip'} . "\n";
		}
	}
	else
	{
		$recv_tab = 0;
	}
}

